C  Regression de modele II           ------         Modele II regression
C
C  Axe majeur (AM), axe majeur reduit (AMR), moindres carres ordinaires
C  (MCO), axe majeur des donees cadrees (AMDC). Un test par permutation 
C  est disponible pour la pente AM, OLS et AMDC ainsi que pour le coef-
C  ficient de correlation r.
C
C  Major axis (MA), standard major axis (SMA), ordinary least-squares
C  (OLS), ranged major axis (RMA). A randomization test is available for
C  the slopes of MA, OLS and RMA, and for the correlation coefficient r.
C
C  Reference: Section 10.3.2 of
C
C  Legendre, P. & L. Legendre. 1998. Numerical ecology, 2nd English 
C     edition. Elsevier Science BV, Amsterdam.
C     
C                                    (c) Pierre Legendre, 1994, 1999, 2000
C ----------------------------------------------------------------------
C2345678901234567890123456789012345678901234567890123456789012345678901234567890
      Parameter (nmax=500)
      Integer pp(4),eg(4),iordre(nmax)
      Real*8 prob,pi,probb,vbma,vbols,vbrma,vbmaRf,vbrmaRf,vcorr,
     +       bma,bols,brma,corr,critf,epsilon,temp
      Real*8 x(nmax),y(nmax),xprime(nmax),yprime(nmax),yper(nmax),
     +       yprper(nmax)
      Real*8 xbar,ybar,varx,vary,r2,bSup,bInf,t,degrad,raddeg
      Common xbar,ybar,varx,vary,r2,bSup,bInf,t,degrad,raddeg,nn,langue
      Character*79 nom
C
      pi=3.141592653589793
      degrad=pi/180.0
      raddeg=180.0/pi
      epsilon=0.00001
      isur=0
      isurRMA=0
      prob=0.05
C BBEdit is the 'creator' for output files
C     call F_Creator('R*ch')
C Langue du dialogue / Dialog language: 1 = Francais; 2 = English
    2 write(*,*) '(1) Francais'
      write(*,*) '(2) English'
      read(*,*) langue
      if((langue.lt.1).or.(langue.gt.2)) goto 2
      if(langue.eq.1) then
         write(*,*) 'Nom du fichier de resultats?'
         else
         write(*,*) 'Name of file of results?'
         endif
      read(*,*) nom
      open(7,file=nom,status='NEW')
      inquire(unit=7,name=nom)
C En-tete
      write(6,103)
      if(langue.eq.1) then
         write(6,102)
         write(7,102)
         else
         write(6,202)
         write(7,202)
         endif
      write(6,103)
      write(7,103)
      write(6,*)
      write(7,*)
C Iseed
      iseed=0
      do 4 i=1,100
    4 turn=rand(iseed)
C Lecture des donnees
      call ReadData(x,y,nmax)
C Axe majeur des donnees cadrees (AMDC, "RMA")?
    6 if(langue.eq.1) then
         write(*,*) 'Calculer l''axe majeur des donnees cadrees (AMDC)?'
         write(*,*) '(0) non,  (1) oui'
         else
         write(*,*) 'Compute ranged major axis regression (RMA)?'
         write(*,*) '(0) no,  (1) yes'
         endif
      read(*,*) iRMA
      if((iRMA.lt.-1).or.(iRMA.gt.1)) goto 6
      if(iRMA.eq.-1) then
         open(8,file='Permuts.txt',status='NEW')
         write(8,*) 'bma brma brmaC / Subroutine Regression'
         write(8,*)
         endif
      if(iRMA.eq.0) goto 12
C
    8 if(langue.eq.1) then
         write(*,106)
         else
         write(*,206)
         endif
      read(*,*) irangY
      if((irangY.lt.1).or.(irangY.gt.2)) goto 8
C
   10 if(langue.eq.1) then
         write(*,107)
         else
         write(*,207)
         endif
      read(*,*) irangX
      if((irangX.lt.1).or.(irangX.gt.2)) goto 10
C
      call Range(x,y,xprime,yprime,irangY,irangX,nn,nmax)
C      
C Calcul des regressions
   12 t=dsqrt(critf(prob,1,nn-2))
      write(*,104) (nn-2),t
      do 14 i=1,nn
      iordre(i)=i
   14 continue
C
   16 if(langue.eq.1) then
      write(*,*) 
     +'Test de r et des pentes AM, MCO et AMDC par permutation:'
      write(*,*) 'Combien de permutations de y ? (ex. 499, 999, ...)'
      write(*,*) '0 = pas de test par permutation.'
      else
      write(*,*) 
     +'Testing r and slopes of MA, OLS and RMA by permutation:'
      write(*,*) 'How many permutations of y ? (ex. 499, 999, ...)'
      write(*,*) '0 = no permutation test.'
      endif
      read(*,*) nperm
      if(nperm.lt.0) goto 16
      write(*,*)
      do 18 i=1,4
      pp(i)=0
   18 eg(i)=1
C
      call Regressions(0,x,y,xprime,yprime,vbma,vbols,vbrma,vbrmaRf,
     +                 vcorr,nmax,iRMA,ierr)
C
      if(langue.eq.1) then
         write(*,101) xbar,ybar
         write(7,101) xbar,ybar
         write(*,105)
         write(7,105)
         else
         write(*,201) xbar,ybar
         write(7,201) xbar,ybar
         write(*,205)
         write(7,205)
         endif
      vbmaRf=vbma
      if((vbma.gt.1.0).or.(vbma.lt.-1.0)) then
         isur=1
         if(vbma.eq.999.99999) then
            vbma=0.0
            else
            vbma=1.0/vbma
            endif
         endif
      if(iRMA.ne.0) then
         if((vbrma.gt.1.0).or.(vbrma.lt.-1.0)) then
            isurRMA=1
            if(vbrma.eq.999.99999) then
               vbrma=0.0
               else
               vbrma=1.0/vbrma
               endif
            endif
C         if(iRMA.eq.-1) write(10,100) vbma,vbrma
         endif
C
C Debut des permutations. - - - - - - - - - - - - - -
C
C En regression lineaire simple, un test par permutation base sur la
C pente b est equivalent a un test base sur une statistique t, car les
C deux sont equivalents a un test base sur le coeff. de correlation r.
C
C In simple linear regression, a permutation test using b is equivalent
C to a test using t, since both are equivalent to a test using the
C correlation coefficient r.
      if(nperm.eq.0) goto 99
      do 50 iperm=1,nperm
   28 call Permute(iseed,nn,nmax,iordre)
      do 30 i=1,nn
   30 yper(i)=y(iordre(i))
      if(iRMA.ne.0) then
         do 32 i=1,nn
   32    yprper(i)=yprime(iordre(i))
         endif
      call Regressions(iperm,x,yper,xprime,yprper,bma,bols,brma,temp,
     +                 corr,nmax,iRMA,ierr)
      if(ierr.eq.1) goto 28
C Lorsque b1(AM) > 1 ou b1(AM) < -1, on teste b1(AM) sur b1'=1/b1.
C When b1(MA) > 1 or b1(MA) < -1, b1(MA) is tested on b1'=1/b1.
      if(isur.eq.1) bma=1.0/bma
      if(dabs(bma-vbma).lt.epsilon) then
         eg(1)=eg(1)+1
         else
         if(bma.lt.vbma) pp(1)=pp(1)+1
         endif
C Test de la pente de MCO
       if(dabs(bols-vbols).lt.epsilon) then
         eg(2)=eg(2)+1
         else
         if(bols.lt.vbols) pp(2)=pp(2)+1
         endif
C Test de la correlation
      if(dabs(corr-vcorr).lt.epsilon) then
         eg(3)=eg(3)+1
         else
         if(corr.lt.vcorr) pp(3)=pp(3)+1
         endif
C Lorsque b1(AMDC) > 1 ou b1(AMDC) < -1, on teste b1(AMDC) sur b1'=1/b1.
C When b1(RMA) > 1 or b1(RMA) < -1, b1(RMA) is tested on b1'=1/b1.
      if(iRMA.ne.0) then
         if(isurRMA.eq.1) brma=1.0/brma
         if(dabs(brma-vbrma).lt.epsilon) then
            eg(4)=eg(4)+1
            else
            if(brma.lt.vbrma) pp(4)=pp(4)+1
            endif
C         if(iRMA.eq.-1) write(10,100) bma,brma
         endif
   50 continue
C Fin des permutations. - - - - - - - - - - - - - - -
C
C Ecrire le tableau des resultats des permutations
      if(langue.eq.1) then
         write(*,108) nperm
         write(7,108) nperm
         write(*,111)
         write(7,111)
         else
         write(*,208) nperm
         write(7,208) nperm
         write(*,211)
         write(7,211)
         endif
      write(*,116)
      write(7,116)
C   AM, "MA"
      if(vbma.ge.0.0) then
         probb=dfloat(nperm+1-pp(1))/dfloat(nperm+1)
         else
         probb=dfloat(pp(1)+eg(1))/dfloat(nperm+1)
         endif
      if(langue.eq.1) then
         write(*,112) vbmaRf,pp(1),eg(1),(nperm+1-pp(1)-eg(1)),probb
         write(7,112) vbmaRf,pp(1),eg(1),(nperm+1-pp(1)-eg(1)),probb
         else
         write(*,212) vbmaRf,pp(1),eg(1),(nperm+1-pp(1)-eg(1)),probb
         write(7,212) vbmaRf,pp(1),eg(1),(nperm+1-pp(1)-eg(1)),probb
         endif
C   MCO, "OLS"
      if(vbols.ge.0.0) then
         probb=dfloat(nperm+1-pp(2))/dfloat(nperm+1)
         else
         probb=dfloat(pp(2)+eg(2))/dfloat(nperm+1)
         endif
      if(langue.eq.1) then
         write(*,113) vbols,pp(2),eg(2),(nperm+1-pp(2)-eg(2)),probb
         write(7,113) vbols,pp(2),eg(2),(nperm+1-pp(2)-eg(2)),probb
         else
         write(*,213) vbols,pp(2),eg(2),(nperm+1-pp(2)-eg(2)),probb
         write(7,213) vbols,pp(2),eg(2),(nperm+1-pp(2)-eg(2)),probb
         endif
C   Correlation
      if(vcorr.ge.0.0) then
         probb=dfloat(nperm+1-pp(3))/dfloat(nperm+1)
         else
         probb=dfloat(pp(3)+eg(3))/dfloat(nperm+1)
         endif
      write(*,114) vcorr,pp(3),eg(3),(nperm+1-pp(3)-eg(3)),probb
      write(7,114) vcorr,pp(3),eg(3),(nperm+1-pp(3)-eg(3)),probb
C   AMDC, "RMA"
      if(iRMA.ne.0) then
         if(vbRMA.ge.0.0) then
            probb=dfloat(nperm+1-pp(4))/dfloat(nperm+1)
            else
            probb=dfloat(pp(4)+eg(4))/dfloat(nperm+1)
            endif
         if(langue.eq.1) then
            write(*,115) vbrmaRf,pp(4),eg(4),(nperm+1-pp(4)-eg(4)),probb
            write(7,115) vbrmaRf,pp(4),eg(4),(nperm+1-pp(4)-eg(4)),probb
            else
            write(*,215) vbrmaRf,pp(4),eg(4),(nperm+1-pp(4)-eg(4)),probb
            write(7,215) vbrmaRf,pp(4),eg(4),(nperm+1-pp(4)-eg(4)),probb
            endif
         endif
C Terminer le tableau
      write(*,116)
      write(7,116)
      write(*,*)
      write(7,*)
C Fin des calculs de regression
   99 if(langue.eq.1) then
         write(*,*) "Les resultats se trouvent egalement dans ",
     +              "le fichier ",nom
         write(*,*) 'Fin du programme.'
         else
         write(*,*) "Results are also found in file ",nom
         write(*,*) 'End of the program.'
         endif
      close(7)
      stop
  100 format(8f15.5)
  101 format(' b0=ord. a l''origine, b1=pente,',
     +       ' xbar=',f12.5,', ybar=',f12.5/)
  201 format(' b0 = intercept, b1 = slope, ',
     +       ' xbar =',f12.5,', ybar =',f12.5/)
  102 format(/' Regression de modele II'/
     +      ' pour les cas ou y et x sont deux variables aleatoires.'//
     +      ' Estimation des parametres  de l''equation fonctionnelle'/
     +      ' y = b0 + b1*x'/
     +      '                    (c) Pierre Legendre, 1994, 1999, 2000'/
     +      ' Departement de sciences biologiques, Univ. de Montreal'//
     +      '                ------------------------               '//
     +      ' Methodes:   axe majeur (AM),  axe majeur reduit (AMR),'/
     +      ' moindres carres ordinaires (MCO), '/
     +      ' axe majeur des donnees cadrees (AMDC).'//
     +      ' Tests par permutation: r et pentes de AM, MCO et AMDC.'/
     +      ' On ne peut pas tester la pente de AMR par permutation.'/)
  202 format(/' Model II regression'/
     +      ' for situations where variables y and x are both random.'/
     +      ' Estimation of the parameters of the functional equation'/
     +      ' y = b0 + b1*x'/
     +      '                     (c) Pierre Legendre, 1994, 1999, 2000'/
     +      ' Departement de sciences biologiques,  Univ. de Montreal'//
     +      '                ------------------------               '//
     +      ' Methods:   major axis (MA),  standard major axis (SMA),'/
     +      ' ordinary least-squares (OLS),  ranged major axis (RMA).'//
     +      ' Permutation tests: r and slopes of MA, OLS and RMA. The'/
     +      ' slope of SMA cannot be tested by permutation (H0:b1=0).'/)
  103 format(1x,55('-'))
  104 format(' t(',i3,') =',f10.5/)
  105 format(' Code 999.99999 si la pente est infinie (angle = 90*)'//
     + ' Code   0.00000 si les bornes de l''I.C. ne peuvent etre'/
     + ' calculees; quand les deux valeurs propres sont trop'/
     + ' semblables, l''I.C. incorpore les 360* du plan.'/)
  205 format(' Code 999.99999 if the slope is infinite (90* angle).'//
     + ' Code   0.00000 if the limits of the C.I. cannot be computed.'/
     + ' This may happen when the two eigenvalues are too similar;' /
     + ' the C.I. then incorporates all 360* of the plane.'/)
  106 format(/' Cadrage de la variable reponse (y):'/
     +        ' (1) Variation relative a un vrai zero: y'' = y/ymax'/
     +        ' (2) Zero arbitraire (variation par intervalle):',
     +        ' y'' = (y-ymin)/(ymax-ymin)')
  206 format(/' Ranging for the response variable (y):'/
     +   ' (1) Variation relative to a true zero value: y'' = y/ymax'/
     +   ' (2) Arbitrary zero (interval-scale var.):',
     +   ' y'' = (y-ymin)/(ymax-ymin)')
  107 format(/' Cadrage de la variable explicative (x):'/
     +        ' (1) Variation relative a un vrai zero: x'' = x/xmax'/
     +        ' (2) Zero arbitraire (variation par intervalle):',
     +        ' x'' = (x-xmin)/(xmax-xmin)')
  207 format(/' Ranging for the explanatory variable (x):'/
     +   ' (1) Variation relative to a true zero value: x'' = x/xmax'/
     +   ' (2) Arbitrary zero value (interval-scale):',
     +   ' x'' = (x-xmin)/(xmax-xmin)')
  108 format(/1x,40('-')/' Test par permutation des pentes et de r'
     +       /1x,40('-')//' Nombre de permutations aleatoires =',i6/)
  208 format(/1x,44('-')/' Permutation tests on slopes and correlation'
     +       /1x,44('-')//' Number of random permutations:',i6/)
  111 format(
     +1x,48('-')/' Methode   Stat.    PP    EG    PG  p unilaterale')
  211 format(
     +1x,48('-')/' Method    Stat.    LT    EQ    GT   One-tailed p')
  112 format(/' AM   ',f10.5,3i6,f12.5)
  212 format(/' MA   ',f10.5,3i6,f12.5)
  113 format(/' MCO  ',f10.5,3i6,f12.5)
  213 format(/' OLS  ',f10.5,3i6,f12.5)
  114 format(/' Corr ',f10.5,3i6,f12.5)
  115 format(/' AMDC ',f10.5,3i6,f12.5)
  215 format(/' RMA  ',f10.5,3i6,f12.5)
  116 format(1x,48('-'))
      end

      Function CritF(p,df1,df2)
C Computes critical F value to produce a given probability
C	Programmer:   Gary Perlman
C	Organization: Wang Institute, Tyngsboro, MA 01879
C
C   Translated from C to FORTRAN by Pierre Legendre, 
C   Universite de Montreal, August 1994.
C   (With help from Philippe Casgrain)
C
C ALGORITHM:
C	Begin with upper and lower limits for F values (maxf and minf)
C	set to extremes.  Choose an F value (fval) between the extremes.
C	Compute the probability of the F value.  Set minf or maxf, based
C	on whether the probability is less than or greater than the
C	desired p.  Continue adjusting the extremes until they are
C	within F_EPSILON of each other.
      Integer 	df1,df2
      Real*8	p,critf,fval,maxf,minf,F_EPSILON,pof
      F_EPSILON=0.000001
      maxf = 9999.0
      minf = 0.0
      if ((p.le.0.0).or.(p.ge.1.0)) then
         critf=0.0
         return
         endif
      fval = 1.0 / p
      do 10 i=1,1000
      if(dabs(maxf - minf).gt.F_EPSILON) then
            if (pof(fval, df1, df2).lt.p) then
               maxf = fval
               else
               minf = fval
               endif
            fval = (maxf + minf) * 0.5
         else
            critf=fval
            return
         endif
      if(i.eq.1000) write(*,101)
   10 continue
C
  101 format(' CRITF n''a pas converge en 1000 iterations')
      end
      
      Subroutine MA(iperm,x,y,nmax,b0,b1,ierr,ilimit)
      Real*8 D,lambd1,lambd2,H,A,sx,sy,sx2,sy2,sxy,covxy,b0,b1,temp
      Real*8 x(nmax),y(nmax)
      Real*8 xbar,ybar,varx,vary,r2,bSup,bInf,t,degrad,raddeg
      Common xbar,ybar,varx,vary,r2,bSup,bInf,t,degrad,raddeg,nn,langue
      Common /Stat2/ sx,sy,sx2,sy2,sxy,covxy
      ilimit=0
      sx=0.
      sx2=0.
      sy=0.
      sy2=0.
      sxy=0.
      do 2 i=1,nn
      sx=sx+x(i)
      sx2=sx2+x(i)*x(i)
      sy=sy+y(i)
      sy2=sy2+y(i)*y(i)
      sxy=sxy+x(i)*y(i)
    2 continue
      xbar=sx/dfloat(nn)
      ybar=sy/dfloat(nn)
C Attention: les valeurs 'varx', 'vary' et 'covxy' ne sont pas divisees
C par (nn-1), car cela est inutile pour calculer b1.
C Ce sont donc de simples sommes de carres d'ecarts (SCE).
      varx=sx2-sx*sx/dfloat(nn)
      vary=sy2-sy*sy/dfloat(nn)  
      covxy=sxy-sx*sy/dfloat(nn)
      if(vary.eq.0) stop 'No variation in y.'
      if(varx.eq.0) stop 'No variation in x.'
      r2=covxy*covxy/(varx*vary)
C   Pente nulle ou infinie
      if(covxy.eq.0) then
         if(iperm.eq.0) then
            if(varx.ge.vary) then
               b1=0.0
               b0=ybar
               else
               b0=999.99999
               b1=999.99999
               bInf=0.00000
               bSup=0.00000
               return
               endif
           else
            ierr=1
            return
           endif
         else
C   Pente non infinie
         temp=vary-varx
         b1=(temp+dsqrt((temp**2)+4.0*(covxy**2)))/(2.0*covxy)
         if(iperm.ne.0) return
         b0=ybar-b1*xbar
         endif
C Calcul de l'intervalle de confiance (95%) de b1, selon Sokal & Rohlf
C (1981: 596-597).
   10 D=dsqrt((varx+vary)**2-4.0*(varx*vary-covxy**2))
      lambd1=varx+vary+D
      lambd2=varx+vary-D
      if(langue.eq.1) then
         temp=2.0*dfloat(nn-1)
         write(*,101) lambd1/temp,lambd2/temp
         write(7,101) lambd1/temp,lambd2/temp
         else
         temp=2.0*dfloat(nn-1)
         write(*,201) lambd1/temp,lambd2/temp
         write(7,201) lambd1/temp,lambd2/temp
         endif
      if(lambd2.eq.0.0) then
         bInf=b1
         bSup=b1
         return
         endif
      if(lambd1.eq.lambd2) then
         temp=datan(b1)*raddeg
         bInf=dtan((temp-90.0)*degrad)
         bSup=dtan((temp+90.0)*degrad)
         return
         endif
      H=t*t/(((lambd1/lambd2)+(lambd2/lambd1)-2.0)*dfloat(nn-2))
      if(H.ge.1.0) then
         bInf=0.00000
         bSup=0.00000
         ilimit=1
         return
         endif
      A=dsqrt(H/(1.0-H))
      if(b1*A.eq.-1.0) then
         bInf=-999.99999
         else
         bInf=(b1-A)/(1.0+b1*A)
         endif
      if(b1*A.eq.1.0) then
         bSup= 999.99999
         else
         bSup=(b1+A)/(1.0-b1*A)
         endif
	     return
  100 format(8f10.5)
  101 format(' Valeurs propres: lambda 1 =',f14.5,'  lambda 2 =',f14.5)
  201 format(' Eigenvalues:   lambda 1 =',f15.5,'  lambda 2 =',f15.5)
      end

      Subroutine OLS(iperm,x,y,r,b0Inf,b0Sup,nmax,b0,b1)
      Real*8 sx,sy,sx2,sy2,sxy,covxy,r,SCEE,dif,varb1,varb0,b0Inf,b0Sup,
     +       b0,b1
      Real*8 x(nmax),y(nmax)
      Real*8 xbar,ybar,varx,vary,r2,bSup,bInf,t,degrad,raddeg
      Common xbar,ybar,varx,vary,r2,bSup,bInf,t,degrad,raddeg,nn,langue
      Common /Stat2/ sx,sy,sx2,sy2,sxy,covxy
C
C Calcul des parametres
      b1=covxy/varx
      b0=ybar-b1*xbar
      r=covxy/dsqrt(varx*vary)
      if(iperm.ne.0) return
C
C Calcul de l'intervalle de confiance (95%) de b1
      SCEE=0.0
      do 10 i=1,nn
      dif=y(i)-b0-b1*x(i)
   10 SCEE=SCEE+dif*dif
C Dans l'expression pour 'varb1', 'dfloat(nn-1)' devrait apparaitre au
C denominateur. Il n'y est pas parce que 'varx' est en fait SCE(x).
      varb1=SCEE/(dfloat(nn-2)*varx)
      bSup=b1+t*dsqrt(varb1)
      bInf=b1-t*dsqrt(varb1)
C
C I.C. 95% de l'ordonnee a l'origine selon StatView et Scherrer (p. 656)
      varb0=SCEE*sx2/(varx*dfloat(nn*(nn-2)))
      b0Sup=b0+t*dsqrt(varb0)
      b0Inf=b0-t*dsqrt(varb0)
      return
      end

      Subroutine Permute(iseed,n,nmax,iordre)
C This subroutine permutes the first 'n' values of vector 'iordre' at random
C in an equiprobable way. This property has been checked through intensive 
C simulations.
      Integer iseed,i,j,itemp,km1,m,n,nmax
      Integer iordre(nmax)
      m=n
      km1=n-1
      do 10 i=1,km1
    8    j = 1 + rand(iseed)*m
         if(j.gt.m) goto 8
         itemp = iordre(m)
         iordre(m) = iordre(j)
         iordre(j) = itemp
         m = m-1
   10 continue
      return
      end

      Function Pof(F,df1,df2)
C ALGORITHM Compute probability of F ratio.
C	Adapted from Collected Algorithms of the CACM
C	Algorithm 322
C	Egon Dorrer
      Integer df1,df2,a,b,i,j
      Real*8  I_PI,pof,F,w, y, z, d, p, F_EPSILON
      F_EPSILON=0.000001
      I_PI=0.3183098861837906715377675	
C
      if((F.lt.F_EPSILON).or.(df1.lt.1).or.(df2.lt.1)) then
         pof=1.0
         return
		 endif
      if(mod(df1,2).gt.0) then
         a=1
         else
         a=2
         endif
      if(mod(df2,2).gt.0) then
         b=1
         else
         b=2
         endif
      w = (F * dfloat(df1)) / dfloat(df2)
      z = 1.0 / (1.0 + w)
	     if (a.eq.1) then
	        if (b.eq.1) then
               p = dsqrt (w)
               y = I_PI
               d = y * z / p
               p = 2.0 * y * datan(p)
            else
               p = dsqrt (w * z)
               d = 0.5 * p * z / w
            endif
	     else if (b.eq.1) then
            p = dsqrt (z)
            d = 0.5 * z * p
            p = 1.0 - p
	     else
            d = z * z
            p = w * z
         endif
	     y = 2.0 * w / z
      do 10 j = (b+2), df2, 2
      d = d * ((1.0 + dfloat(a) / dfloat(j-2)) * z)
      if(a.eq.1) then
         p = p + d * y / dfloat(j-1)
         else
         p = (p + w) * z
         endif
   10 continue
      y = w * z
      z = 2.0 / z
      b = df2 - 2
      do 20 i = (a+2), df1, 2
      j = i + b
      d = d * (y * dfloat(j) / dfloat(i-2))
      p = p - (z * d / dfloat(j))
   20 continue
C Correction for approximation errors suggested in certification 
      if (p.lt.0.0) then
            p = 0.0
         else if (p.gt.1.0) then
            p = 1.0
         endif
      pof=1.0-p
C
      return
      end

      Subroutine Range(x,y,xprime,yprime,irangY,irangX,nn,nmax)
      Real*8 x(nmax),y(nmax),xprime(nmax),yprime(nmax)
      Real*8 ymin,ymax,xmin,xmax,rangeY,rangeX
      Common /Stat1/ ymin,ymax,xmin,xmax,rangeY,rangeX
C Cadrage des donnees en vue de AMDC ("RMA")
      ymin=y(1)
      ymax=y(1)
      xmin=x(1)
      xmax=x(1)
C Trouver les bornes de cadrage
      do 10 i=2,nn
      if(y(i).lt.ymin) ymin=y(i)
      if(y(i).gt.ymax) ymax=y(i)
      if(x(i).lt.xmin) xmin=x(i)
      if(x(i).gt.xmax) xmax=x(i)
   10 continue
      if(irangY.eq.1) then
         if(ymin.lt.0.0) then
            write(*,*) 'ymin < 0'
            else
            ymin=0.0
            endif
         endif
      if(irangX.eq.1) then
         if(xmin.lt.0.0) then
            write(*,*) 'xmin < 0'
            else
            xmin=0.0
            endif
         endif
C Cadrer les valeurs de y et x
      rangeY=ymax-ymin
      rangeX=xmax-xmin
      if(rangeY.eq.0) stop 'No variation in y.'
      if(rangeX.eq.0) stop 'No variation in x.'
      do 20 i=1,nn
      yprime(i)=(y(i)-ymin)/rangeY
      xprime(i)=(x(i)-xmin)/rangeX
   20 continue
      return
      end
      
      Subroutine ReadData(x,y,nmax)
      Real*8 x(nmax),y(nmax)
      Real*8 xbar,ybar,varx,vary,r2,bSup,bInf,t,degrad,raddeg
      Common xbar,ybar,varx,vary,r2,bSup,bInf,t,degrad,raddeg,nn,langue
      Character dataf*40
      Character*79 namea
C Lecture des donnees  
      if(langue.eq.1) then
         write(*,*) 
     +   'Nom du fichier de donnees (2 colonnes: x et y, ou y et x)'
         else
         write(*,*) 
     +   'Name of input data file (2 columns: x and y, or y and x)'
         endif
C      read(*,'(a40)') dataf
      read(*,*) namea
      open(1,file=namea,Status='OLD')
      inquire(unit=1,name=namea)
      if(langue.eq.1) then
         write(*,*) 'Fichier de donnees: ',namea
         write(7,*) 'Fichier de donnees: ',namea
         else
         write(*,*) 'Input data file: ',namea
         write(7,*) 'Input data file: ',namea
         endif
      write(*,*)
      write(7,*)
      if(langue.eq.1) then
         write(*,102) nmax
         else
         write(*,202) nmax
         endif
      read(*,*) nn
      write(*,*)
      if(nn.gt.nmax) then 
         if(langue.eq.1) then
            stop 'Matrice trop grande. Redimensionnez le programme.'
            else
            stop 'Matrix too large. Redimension the program.'
            endif
         endif
   12 if(langue.eq.1) then
         write(*,*)'Identification de la variable dependante y:'
         write(*,*)'1 = x d''abord, y ensuite ?'
         write(*,*)'2 = y d''abord, x ensuite ?'
         else
         write(*,*)'Identifying the dependent variable y:'
         write(*,*)'1 = x first, y last ?'
         write(*,*)'2 = y first, x last ?'
         endif
      read(*,*) iformxy
      if((iformxy.lt.1).or.(iformxy.gt.2)) goto 12
C
      if(iformxy.eq.1) then
         do 14 i=1,nn
   14    read(1,*) x(i),y(i)
         else
         do 16 i=1,nn
   16    read(1,*) y(i),x(i)
         endif
      if(langue.eq.1) then
         write(*,*)'Fin de la lecture des donnees.'
         else
         write(*,*)'The input data matrix has been read.'
         endif
      write(*,*)
      close(1)
      return
  102 format(' Nombre de lignes de la matrice ? (Maximum =',i5,')')
  202 format(' Number of rows in input data matrix ? (Maximum =',i5,')')
      end
      
      Subroutine Regressions(iperm,x,y,xprime,yprime,bma,bols,brma,
     +                       brmaC,corr,nmax,iRMA,ierr)
      Real*8 bma,bols,brma,brmaC,corr,b0,b1,bInf1,bSup1
      Real*8 x(nmax),y(nmax),xprime(nmax),yprime(nmax)
      Real*8 ymin,ymax,xmin,xmax,rangeY,rangeX,angle,aInf,aSup
      Real*8 xbar,ybar,varx,vary,r2,bSup,bInf,t,degrad,raddeg
      Common xbar,ybar,varx,vary,r2,bSup,bInf,t,degrad,raddeg,nn,langue
      Common /Stat1/ ymin,ymax,xmin,xmax,rangeY,rangeX
C ----------------------------------------------------------------------
C Regression Axe Majeur (AM, "MA")
      ierr=0
      if(iperm.eq.0) then
         write(6,104)
         write(7,104)
         if(langue.eq.1) then
            write(*,*) 'Axe majeur (AM,"MA"):'
            write(7,*) 'Axe majeur (AM,"MA"):'
            else
            write(*,*) 'Major axis (MA):'
            write(7,*) 'Major axis (MA):'
            endif
         endif
      call MA(iperm,x,y,nmax,b0,b1,ierr,ilimit)
      if(ierr.eq.1) return
      bma=b1
      if(iperm.ne.0) goto 70
C   Pour la valeur de reference:
      if(b1.eq.999.99999) then
         angle=90.0
         aInf=0.00000
         aSup=0.00000
        else if(ilimit.eq.1) then
         angle=datan(bma)*raddeg
         aInf=0.00000
         aSup=0.00000
        else
         angle=datan(bma)*raddeg
         if(xbar.ge.0) then
            aInf=ybar-bSup*xbar
            aSup=ybar-bInf*xbar
            if(bInf.eq.-999.99999) aSup=0.00000
            if(bSup.eq. 999.99999) aInf=0.00000
            else
            aSup=ybar-bSup*xbar
            aInf=ybar-bInf*xbar
            if(bInf.eq.-999.99999) aInf=0.00000
            if(bSup.eq. 999.99999) aSup=0.00000
            endif
        endif
      if(langue.eq.1) then
         write(*,105) b0,b1,angle,bInf,bSup,aInf,aSup
         write(7,105) b0,b1,angle,bInf,bSup,aInf,aSup
         else
         write(*,205) b0,b1,angle,bInf,bSup,aInf,aSup
         write(7,205) b0,b1,angle,bInf,bSup,aInf,aSup
         endif
      write(6,104)
      write(7,104)
C ----------------------------------------------------------------------
C Regression axe majeur reduit (AMR, "SMA")
      if(langue.eq.1) then
         write(*,*) 'Axe majeur reduit (AMR,"SMA"):'
         write(7,*) 'Axe majeur reduit (AMR,"SMA"):'
         else
         write(*,*) 'Standard major axis (SMA):'
         write(7,*) 'Standard major axis (SMA):'
         endif
      call SMA(b0,b1)
      angle=datan(b1)*raddeg
      if(xbar.ge.0) then
         aInf=ybar-bSup*xbar
         aSup=ybar-bInf*xbar
         else
         aSup=ybar-bSup*xbar
         aInf=ybar-bInf*xbar
         endif
      if(langue.eq.1) then
         write(*,105) b0,b1,angle,bInf,bSup,aInf,aSup
         write(7,105) b0,b1,angle,bInf,bSup,aInf,aSup
         else
         write(*,205) b0,b1,angle,bInf,bSup,aInf,aSup
         write(7,205) b0,b1,angle,bInf,bSup,aInf,aSup
         endif
      if(langue.eq.1) then
         write(*,*) 'I.C. de la pente selon ',
     +   'Jolicoeur & Mosimann (1968),  McArdle (1988)'
         write(7,*) 'I.C. de la pente selon ',
     +   'Jolicoeur & Mosimann (1968),  McArdle (1988)'
         write(6,104)
         write(7,104)
         else
         write(*,*) 'C.I. of slope following ',
     +   'Jolicoeur & Mosimann (1968), McArdle (1988)'
         write(7,*) 'C.I. of slope following ',
     +   'Jolicoeur & Mosimann (1968), McArdle (1988)'
         write(6,104)
         write(7,104)
         endif
C ----------------------------------------------------------------------
C Regression par moindres carres ordinaires (MCO, "OLS")
   70 if(iperm.eq.0) then
         if(langue.eq.1) then
            write(*,*) 'Moindres Carres Ordinaires (MCO,"OLS"):'
            write(7,*) 'Moindres Carres Ordinaires (MCO,"OLS"):'
            else
            write(*,*) 'Ordinary least-squares (OLS):'
            write(7,*) 'Ordinary least-squares (OLS):'
            endif
         endif
      call OLS(iperm,x,y,corr,aInf,aSup,nmax,b0,b1)
      bols=b1
      if(iperm.ne.0) goto 80
      angle=datan(b1)*raddeg
      if(langue.eq.1) then
         write(*,106) corr,r2,b0,b1,angle,bInf,bSup,aInf,aSup
         write(7,106) corr,r2,b0,b1,angle,bInf,bSup,aInf,aSup
         else
         write(*,206) corr,r2,b0,b1,angle,bInf,bSup,aInf,aSup
         write(7,206) corr,r2,b0,b1,angle,bInf,bSup,aInf,aSup
         endif
      write(6,104)
      write(7,104)
C ----------------------------------------------------------------------
C Regression axe majeur des donnees cadrees (AMDC, "RMA")
   80 if(iRMA.eq.0) return
      if(iperm.eq.0) then
         if(langue.eq.1) then
            write(*,*) 'Axe majeur des donnees cadrees (AMDC,"RMA"):'
            write(7,*) 'Axe majeur des donnees cadrees (AMDC,"RMA"):'
            else
            write(*,*) 'Ranged major axis (RMA):'
            write(7,*) 'Ranged major axis (RMA):'
            endif
         write(*,107) ymin,ymax,xmin,xmax
         write(7,107) ymin,ymax,xmin,xmax
         endif
      call MA(iperm,xprime,yprime,nmax,b0,b1,ierr,ilimit)
      if(ierr.eq.1) return
      brma=b1
      if(b1.eq.999.99999) then
         brmaC=b1
         else
         brmaC=b1*rangeY/rangeX
         endif
      if(iRMA.eq.-1) write(8,100) bma,brma,brmaC
      if(iperm.ne.0) return
C   Pour la valeur de reference:
      ybar=(ybar*rangeY)+ymin
      xbar=(xbar*rangeX)+xmin
      bSup1=bSup
      bInf1=bInf
      bSup=bSup*rangeY/rangeX
      bInf=bInf*rangeY/rangeX
C
      if(b1.eq.999.99999) then
         angle=90.0
         aInf=0.00000
         aSup=0.00000
        else if(ilimit.eq.1) then
         angle=datan(brmaC)*raddeg
         aInf=0.00000
         aSup=0.00000
        else
         b0=ybar-brmaC*xbar
         angle=datan(brmaC)*raddeg
         if(xbar.ge.0) then
            aInf=ybar-bSup*xbar
            aSup=ybar-bInf*xbar
            if(bInf1.eq.-999.99999) aSup=0.00000
            if(bSup1.eq. 999.99999) aInf=0.00000
            else
            aSup=ybar-bSup*xbar
            aInf=ybar-bInf*xbar
            if(bInf1.eq.-999.99999) aInf=0.00000
            if(bSup1.eq. 999.99999) aSup=0.00000
            endif
         endif
      if(langue.eq.1) then
         write(*,105) b0,brmaC,angle,bInf,bSup,aInf,aSup
         write(7,105) b0,brmaC,angle,bInf,bSup,aInf,aSup
         else
         write(*,205) b0,brmaC,angle,bInf,bSup,aInf,aSup
         write(7,205) b0,brmaC,angle,bInf,bSup,aInf,aSup
         endif
      write(6,104)
      write(7,104)
C ----------------------------------------------------------------------
      return
  100 format(8f15.5)
  104 format(1x,67('-')/)
  105 format(/' b0 =',f10.5,'    b1 =',f10.5,'    angle (*) =',f10.5//
     +' I.C. 95% de la pente = [',f10.5,', ',f10.5,']'/
     +' I.C. 95% de l''ordonnee a l''origine'/
     +'                      = [',f10.5,', ',f10.5,']',
     +'   (sous-estimation)'/)
  205 format(/' b0 =',f10.5,'    b1 =',f10.5,'    angle (*) =',f10.5//
     +' 95% C.I. of slope     = [',f10.5,', ',f10.5,']'/
     +' 95% C.I. of intercept = [',f10.5,', ',f10.5,']',
     +'    (underestimate)'/)
  106 format(11x,'r =',f10.5,'   coeff. de determination (r^2) =',f10.5/
     +/' b0 =',f10.5,'    b1 =',f10.5,'    angle (*) =',f10.5//
     +' I.C. 95% de la pente = [',f10.5,', ',f10.5,']'/
     +' I.C. 95% de l''ordonnee a l''origine'/
     +'                      = [',f10.5,', ',f10.5,']'/)
  206 format(11x,'r =',f10.5,'   coeff. of determination (r^2) =',f10.5/
     +/' b0 =',f10.5,'    b1 =',f10.5,'    angle (*) =',f10.5//
     +' 95% C.I. of slope     = [',f10.5,', ',f10.5,']'/
     +' 95% C.I. of intercept = [',f10.5,', ',f10.5,']'/)
  107 format(
     +' ymin =',f10.5,' ymax =',f10.5,' xmin =',f10.5,' xmax =',f10.5)
      end

      Subroutine SMA(b0,b1)
      Real*8 sx,sy,sx2,sy2,sxy,covxy,B,b0,b1
      Real*8 xbar,ybar,varx,vary,r2,bSup,bInf,t,degrad,raddeg
      Common xbar,ybar,varx,vary,r2,bSup,bInf,t,degrad,raddeg,nn,langue
      Common /Stat2/ sx,sy,sx2,sy2,sxy,covxy
C Calcul des parametres de l'axe majeur reduit
C
C La pente de SMA recoit le signe de la covariance
C La commande Fortran Sign, qui opere un transfert de signe, a 2 arguments.
C Pour les 'real': sign(x,y) => x fois le signe de y.
C Ex.              sign(-2.0, -24.3) = -2 x -1 = 2
C Pour les 'integer': isign(i,j). Pour les 'Real*8': dsign(x,y).
      b1=dsign(dsqrt(vary/varx),covxy)
      b0=ybar-b1*xbar
C I.C. de b1, selon Jolicoeur & Mosimann (1968) et McArdle (1988: 2332)
      B=t*t*(1.0-r2)/dfloat(nn-2)
      if(b1.gt.0.0) then
         bInf=b1*(dsqrt(B+1.0)-dsqrt(B))
         bSup=b1*(dsqrt(B+1.0)+dsqrt(B))
         else
         bSup=b1*(dsqrt(B+1.0)-dsqrt(B))
         bInf=b1*(dsqrt(B+1.0)+dsqrt(B))
         endif
	  return
  100 format(8f10.5)
      end
